/**
  System Interrupts Generated Driver File 

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.c

  @Summary:
    This is the generated manager file for the MPLAB(c) Code Configurator device.  This manager
    configures the pins direction, initial state, analog setting.
    The peripheral pin select, PPS, configuration is also handled by this manager.

  @Description:
    This source file provides implementations for MPLAB(c) Code Configurator interrupts.
    Generation Information : 
        Product Revision  :  MPLAB(c) Code Configurator - 4.35
        Device            :  PIC24FJ128GA202
    The generated drivers are tested against the following:
        Compiler          :  XC16 1.32
        MPLAB             :  MPLAB X 3.61

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


/**
    Section: Includes
*/
#include <xc.h>
#include "pin_manager.h"

/**
    void PIN_MANAGER_Initialize(void)
*/
void PIN_MANAGER_Initialize(void)
{
    /****************************************************************************
     * Setting the Output Latch SFR(s)
     ***************************************************************************/
    LATA = 0x0000;
    LATB = 0x0000;

    /****************************************************************************
     * Setting the GPIO Direction SFR(s)
     ***************************************************************************/
    TRISA = 0x000F;
    TRISB = 0xFFE7;

    /****************************************************************************
     * Setting the Weak Pull Up and Weak Pull Down SFR(s)
     ***************************************************************************/
    CNPD1 = 0x0000;
    CNPD2 = 0x0000;
    CNPD3 = 0x0000;
    CNPU1 = 0x0000;
    CNPU2 = 0x0000;
    CNPU3 = 0x0000;

    /****************************************************************************
     * Setting the Open Drain SFR(s)
     ***************************************************************************/
    ODCA = 0x0000;
    ODCB = 0x0000;

    /****************************************************************************
     * Setting the Analog/Digital Configuration SFR(s)
     ***************************************************************************/
    ANSA = 0x000F;
    ANSB = 0xF20B;


    /****************************************************************************
     * Set the PPS
     ***************************************************************************/
    __builtin_write_OSCCONL(OSCCON & 0xbf); // unlock PPS

    RPOR1bits.RP3R = 0x000D;   //RB3->OC1:OC1;

    __builtin_write_OSCCONL(OSCCON | 0x40); // lock   PPS

    /****************************************************************************
     * Interrupt On Change for group CNEN1 - any
     ***************************************************************************/
	CNEN1bits.CN6IE = 1; // Pin : RB2

    IEC1bits.CNIE = 1; // Enable CNI interrupt 
}

unsigned char __CN_SEMAPHORE = 0;
unsigned char glob_CN_SIGNAL = 0;

/* Interrupt service routine for the CNI interrupt. */
void __attribute__ (( interrupt, no_auto_psv )) _CNInterrupt ( void )
{
    if(IFS1bits.CNIF == 1)
    {
        
        /*
        unsigned char temp = LATBbits.LATB3;
        
        if(temp)
            temp=0;
        else
            temp=0xFF;
        
        PORTBbits.RB3 = temp;
        */
        //static unsigned char changedTwice = 0;
        
        //if(!changedTwice)
            //changedTwice = 1;
        
        unsigned short rb2 = PORTBbits.RB2;
        
        if(rb2)
        {
            //changedTwice = 0;
            
            __CN_SEMAPHORE = 1;
            
            glob_CN_SIGNAL = 1;
            /*  // jetzt in Timer 5 Interrupt
            if()
            {
                glob_RotationDelay |= 0x80000000;
        
                if(glob_DirSave) // Schiebetr zu
                {
                OC1R = 4000; // 10% Duty  schnell links gegen uhrzeigersinn
                //glob_ResetServo = 16; // viertel umdrehung gegen uhrzeiger
                glob_ResetServo = 30; // viertel umdrehung gegen uhrzeiger
                }
                else // Schiebetr auf
                {
                OC1R = 2000;  // 5% Duty schnell rechts
                //glob_ResetServo = 16; // viertel umdrehung im uhrzeiger
                glob_ResetServo = 30; // viertel umdrehung gegen uhrzeiger
                }
            
                glob_DirSave = !glob_DirSave;
             
            }
             
             */
            
            __CN_SEMAPHORE = 0;
            
        }
        
        
        // Clear the flag
        IFS1bits.CNIF = 0;
    }
}


/*
 TRISB = 0xFF00; // Configure PORTB<15:8> as inputs and PORTB<7:0> as outputs
Nop(); // Delay 1 cycle
If (PORTBbits.RB13){ };
 */